(** * Verification: oscstat*)

Require ModelProperties.

Require AuxiliaryLemmas.

Section oscstatIsSecure.

(** -------------------------------------------*)

Lemma OscstatPSS:
 (s,t:SFSstate; u:SUBJECT)
  (SecureState s)->(TransFunc u s Oscstat t)->(SecureState t).
OpDontChangeStPSS.
Qed.

(** -------------------------------------------*)

Lemma OscstatPSP:
 (s,t:SFSstate; u:SUBJECT)
  (StarProperty s)->(TransFunc u s Oscstat t)->(StarProperty t).
OpDontChangeStPSP.
Qed.

(** -------------------------------------------*)

Lemma OscstatPCP:
    (s,t:SFSstate)(PreservesControlProp s Oscstat t).
Intros; Unfold PreservesControlProp; Intros Sub TF; Inversion TF;
  Unfold ControlProperty.
Split.
Intros.
Split.
Intro.
Absurd (DACCtrlAttrHaveChanged t t o0); Auto.

Intro; Absurd (MACObjCtrlAttrHaveChanged t t o0); Auto.

Intros; Absurd (MACSubCtrlAttrHaveChanged t t u0); Auto.

Qed.


End oscstatIsSecure.

Hints Resolve OscstatPSS OscstatPSP OscstatPCP.

