(** * Verification: owner_close*)

Require ModelProperties.

Require AuxiliaryLemmas.

Section owner_closeIsSecure.

(** -------------------------------------------*)

Lemma Owner_ClosePSS:
 (s,t:SFSstate; u:SUBJECT)
  (FuncPre5 s)
  ->(SecureState s)->(TransFunc u s Owner_Close t)->(SecureState t).
Intros s t Sub FP5 SS TF; Inversion TF.
Inversion H.
Unfold SecureState.
BreakSS .
Split.
Unfold DACSecureState; Intros; Simpl.
Elim (OBJeq_dec o o0); Intro y0.
Rewrite <- y0.
Cut (fsecmat (secmat s) o)=(None ReadersWriters)
    ->(fsecmat (ownerclose_sm s u o) o)=(None ReadersWriters).
Cut Cases (fsecmat (ownerclose_sm s u o) o) (fsecmat (secmat s) o) of
      _ None => False
    | None (Some z) => True
    | (Some y) (Some z) =>
       ((set_In u0 (ActReaders y))->(set_In u0 (ActReaders z)))
       /\((set_In u0 (ActWriters y))->(set_In u0 (ActWriters z)))
    end.
Cut Cases (fsecmat (secmat s) o) of
      None => True
    | (Some y) =>
       ((set_In u0 (ActReaders y))->(PreDACRead s u0 o))
       /\((set_In u0 (ActWriters y))->(PreDACWrite s u0 o))
    end.
Unfold PreDACRead PreDACWrite; Simpl; Elim (fsecmat (secmat s) o);
  Elim (fsecmat (ownerclose_sm s u o) o); Intros;
  Contradiction Orelse Auto.
Tauto.

Unfold DACSecureState in DAC; Apply DAC.

Apply OwnerClose_smCorr2; Auto.

Auto.

Unfold PreDACRead PreDACWrite; Simpl.
Replace (fsecmat (ownerclose_sm s u o) o0) with (fsecmat (secmat s) o0).
Unfold DACSecureState PreDACRead PreDACWrite in DAC; Apply DAC.

Auto.

Unfold SimpleSecurity; Intros; Simpl.
Elim (OBJeq_dec o o0); Intro y0.
Rewrite <- y0.
Cut Cases (fsecmat (ownerclose_sm s u o) o) (fsecmat (secmat s) o) of
      _ None => False
    | None (Some z) => True
    | (Some y) (Some z) =>
       ((set_In u0 (ActReaders y))->(set_In u0 (ActReaders z)))
       /\((set_In u0 (ActWriters y))->(set_In u0 (ActWriters z)))
    end.
Cut Cases
      (fsecmat (secmat s) o)
    (fOSC (objectSC s) o)
    (fSSC (subjectSC s) u0)
    of
      None _ _ => True
    | _ None _ => True
    | _ _ None => True
    | (Some x) (Some y) (Some z) =>
       (set_In u0 (ActReaders x))\/(set_In u0 (ActWriters x))
       ->(le_sc y z)
    end.
Elim (fsecmat (secmat s) o); Elim (fsecmat (ownerclose_sm s u o) o);
  Elim (fOSC (objectSC s) o); Elim (fSSC (subjectSC s) u0);
  Contradiction Orelse Auto.
Tauto.

Unfold SimpleSecurity in MAC; Apply MAC.

Apply OwnerClose_smCorr2; Auto.

Auto.

Replace (fsecmat (ownerclose_sm s u o) o0) with (fsecmat (secmat s) o0).
Unfold SimpleSecurity in MAC; Apply MAC.

Auto.

Qed.

(** -------------------------------------------*)

Lemma Owner_ClosePSP:
 (s,t:SFSstate; u:SUBJECT)
  (FuncPre5 s)
  ->(StarProperty s)->(TransFunc u s Owner_Close t)->(StarProperty t).
Intros s t Sub FP5 SP TF; Inversion TF.
Inversion H.
Unfold StarProperty; Simpl; Intros.
Cut Cases
      (fsecmat (secmat s) o1)
    (fsecmat (secmat s) o2)
    (fOSC (objectSC s) o2)
    (fOSC (objectSC s) o1)
    of
      None _ _ _ => True
    | _ None _ _ => True
    | _ _ None _ => True
    | _ _ _ None => True
    | (Some w) (Some x) (Some y) (Some z) =>
       (set_In u0 (ActWriters w))
       ->(set_In u0 (ActReaders x))
       ->(le_sc y z)
    end.
Cut Cases (fsecmat (ownerclose_sm s u o) o) (fsecmat (secmat s) o) of
      _ None => False
    | None (Some z) => True
    | (Some y) (Some z) =>
       ((set_In u0 (ActReaders y))->(set_In u0 (ActReaders z)))
       /\((set_In u0 (ActWriters y))->(set_In u0 (ActWriters z)))
    end.
Elim (OBJeq_dec o o1); Elim (OBJeq_dec o o2); Intros EQ2 EQ1.
Rewrite <- EQ1; Rewrite <- EQ2.
Elim (fsecmat (secmat s) o); Elim (fOSC (objectSC s) o);
  Elim (fsecmat (ownerclose_sm s u o) o); Intros; Auto.

Replace (fsecmat (ownerclose_sm s u o) o2) with (fsecmat (secmat s) o2).
Rewrite <- EQ1.
Elim (fsecmat (secmat s) o2); Elim (fOSC (objectSC s) o);
  Elim (fOSC (objectSC s) o2); Elim (fsecmat (secmat s) o);
  Elim (fsecmat (ownerclose_sm s u o) o); Intros;
  Contradiction Orelse Auto.
Tauto.

Auto.

Replace (fsecmat (ownerclose_sm s u o) o1) with (fsecmat (secmat s) o1).
Rewrite <- EQ2.
Elim (fsecmat (secmat s) o1); Elim (fOSC (objectSC s) o);
  Elim (fOSC (objectSC s) o1); Elim (fsecmat (secmat s) o);
  Elim (fsecmat (ownerclose_sm s u o) o); Intros;
  Contradiction Orelse Auto.
Tauto.

Auto.

Replace (fsecmat (ownerclose_sm s u o) o2) with (fsecmat (secmat s) o2).
Replace (fsecmat (ownerclose_sm s u o) o1) with (fsecmat (secmat s) o1).
Auto.

Auto.

Auto.

Apply Close_smCorr2; Auto.

Unfold StarProperty in SP; Apply SP.

Qed.

(** -------------------------------------------*)

Lemma Owner_ClosePCP:
 (s,t:SFSstate)(PreservesControlProp s Owner_Close t).
Intros; Unfold PreservesControlProp; Intros Sub TF; Inversion TF;
  Unfold ControlProperty.
Inversion H.
Split.
Intros.
Split.
Intros;
  Absurd (DACCtrlAttrHaveChanged s
           (mkSFS (groups s) (primaryGrp s) (subjectSC s) (AllGrp s)
             (RootGrp s) (SecAdmGrp s) (objectSC s) (acl s)
             (ownerclose_sm s u o) (files s) (directories s)) o0);
  Auto.

Intros;
  Absurd (MACObjCtrlAttrHaveChanged s
           (mkSFS (groups s) (primaryGrp s) (subjectSC s) (AllGrp s)
             (RootGrp s) (SecAdmGrp s) (objectSC s) (acl s)
             (ownerclose_sm s u o) (files s) (directories s)) o0);
  Auto.

Intros;
  Absurd (MACSubCtrlAttrHaveChanged s
           (mkSFS (groups s) (primaryGrp s) (subjectSC s) (AllGrp s)
             (RootGrp s) (SecAdmGrp s) (objectSC s) (acl s)
             (ownerclose_sm s u o) (files s) (directories s)) u0);
  Auto.

Qed.


End owner_closeIsSecure.

Hints Resolve Owner_ClosePSS Owner_ClosePSP Owner_ClosePCP.

