(** * Verification: read*)

Require ModelProperties.

Require AuxiliaryLemmas.

Section readIsSecure.

(** -------------------------------------------*)

Lemma ReadPSS:
 (s,t:SFSstate; u:SUBJECT)
  (SecureState s)->(TransFunc u s Read t)->(SecureState t).
OpDontChangeStPSS.
Qed.


(** -------------------------------------------*)

Lemma ReadPSP:
 (s,t:SFSstate; u:SUBJECT)
  (StarProperty s)->(TransFunc u s Read t)->(StarProperty t).
OpDontChangeStPSP.
Qed.

(** -------------------------------------------*)

Lemma ReadPCP:
    (s,t:SFSstate)(PreservesControlProp s Read t).
Intros; Unfold PreservesControlProp; Intros Sub TF; Inversion TF;
  Unfold ControlProperty.
Split.
Intros.
Split.
Intro.
Absurd (DACCtrlAttrHaveChanged t t o0); Auto.

Intro; Absurd (MACObjCtrlAttrHaveChanged t t o0); Auto.

Intros; Absurd (MACSubCtrlAttrHaveChanged t t u0); Auto.

Qed.


End readIsSecure.

Hints Resolve ReadPSS ReadPSP ReadPCP.

