(** * Verification: readdir*)


Require ModelProperties.

Require AuxiliaryLemmas.

Section readdirIsSecure.

(** -------------------------------------------*)

Lemma ReaddirPSS:
 (s,t:SFSstate; u:SUBJECT)
  (SecureState s)->(TransFunc u s Readdir t)->(SecureState t).
OpDontChangeStPSS.
Qed.

(** -------------------------------------------*)

Lemma ReaddirPSP:
 (s,t:SFSstate; u:SUBJECT)
  (StarProperty s)->(TransFunc u s Readdir t)->(StarProperty t).
OpDontChangeStPSP.
Qed.

(** -------------------------------------------*)

Lemma ReaddirPCP:
    (s,t:SFSstate)(PreservesControlProp s Readdir t).
Intros; Unfold PreservesControlProp; Intros Sub TF; Inversion TF;
  Unfold ControlProperty.
Split.
Intros.
Split.
Intro.
Absurd (DACCtrlAttrHaveChanged t t o0); Auto.

Intro; Absurd (MACObjCtrlAttrHaveChanged t t o0); Auto.

Intros; Absurd (MACSubCtrlAttrHaveChanged t t u0); Auto.

Qed.


End readdirIsSecure.

Hints Resolve ReaddirPSS ReaddirPSP ReaddirPCP.

